using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
           ModAPI.Register(
	new Modification()
	{
		OriginalItem = ModAPI.FindSpawnable("Human"),
		NameOverride = "Chompster",
		DescriptionOverride = "Chompster",
		CategoryOverride = ModAPI.FindCategory("Entities"),
		ThumbnailOverride = ModAPI.LoadSprite("Chompster Thumb.png"),
		AfterSpawn = (Instance) =>
		{
			foreach (var limb in Instance.GetComponent<PersonBehaviour>().Limbs)
            {
				if (!limb.HasBrain)
				{
					limb.transform.parent.localPosition = Vector3.zero;
				}
				else
				{
					limb.transform.GetChild(0).gameObject.SetActive(false); //brain matter stuff
				}
				if (limb.gameObject.GetComponent<GripBehaviour>() != null)
				{
					GameObject.Destroy(limb.gameObject.GetComponent<GripBehaviour>());
				}
            }


			PersonBehaviour person = Instance.GetComponent<PersonBehaviour>();
person.CountDeathAsStat = false;
  GameObject Limb1 = person.Limbs[0].gameObject;
  Limb1.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin1.png");
  Limb1.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh1.png").texture);
  Limb1.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone1.png").texture);
  Limb1.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage1.png").texture);
  Limb1.transform.localPosition = new Vector3(0.05670806f, 0.4825313f, 0.1f);
  Limb1.transform.eulerAngles = new Vector3(0f, 0f, -0.003065276f) * Mathf.Sign(person.transform.localScale.x);
  Limb1.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Head;
  Limb1.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
  Limb1.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb1.GetComponent<LimbBehaviour>().BaseStrength = 10f;
  Limb1.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb1.GetComponent<LimbBehaviour>().InitialHealth = 1000f;
  Limb1.GetComponent<LimbBehaviour>().Health = 1000f;
  Limb1.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb1.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb1.GetComponent<LimbBehaviour>().Vitality = 10000f;
  Limb1.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb1.GetComponent<CirculationBehaviour>().IsPump = false;
  Limb1.GetComponent<LimbBehaviour>().HasLungs = false;
  Limb1.GetComponent<LimbBehaviour>().IsLethalToBreak = true;
  Limb1.GetComponent<LimbBehaviour>().HasBrain = true;
  GameObject Limb2 = person.Limbs[1].gameObject;
  Limb2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin2.png");
  Limb2.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh2.png").texture);
  Limb2.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone2.png").texture);
  Limb2.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage2.png").texture);
  Limb2.transform.localPosition = new Vector3(0.009675503f, 0.1377611f, 0f);
  Limb2.transform.eulerAngles = new Vector3(0f, 0f, -0.0001742699f) * Mathf.Sign(person.transform.localScale.x);
  Limb2.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Torso;
  Limb2.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
  Limb2.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb2.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
  Limb2.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb2.GetComponent<LimbBehaviour>().InitialHealth = 1000f;
  Limb2.GetComponent<LimbBehaviour>().Health = 1000f;
  Limb2.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb2.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb2.GetComponent<LimbBehaviour>().Vitality = 2f;
  Limb2.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb2.GetComponent<CirculationBehaviour>().IsPump = true;
  Limb2.GetComponent<LimbBehaviour>().HasLungs = true;
  Limb2.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
  Limb2.GetComponent<LimbBehaviour>().HasBrain = false;
  GameObject Limb3 = person.Limbs[2].gameObject;
  Limb3.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin3.png");
  Limb3.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh3.png").texture);
  Limb3.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone3.png").texture);
  Limb3.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage3.png").texture);
  Limb3.transform.localPosition = new Vector3(-0.4360356f, -0.1287172f, -0.1f);
  Limb3.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
  Limb3.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Legs;
  Limb3.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
  Limb3.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb3.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
  Limb3.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb3.GetComponent<LimbBehaviour>().InitialHealth = 350f;
  Limb3.GetComponent<LimbBehaviour>().Health = 350f;
  Limb3.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb3.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb3.GetComponent<LimbBehaviour>().Vitality = 2f;
  Limb3.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb3.GetComponent<CirculationBehaviour>().IsPump = false;
  Limb3.GetComponent<LimbBehaviour>().HasLungs = false;
  Limb3.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
  Limb3.GetComponent<LimbBehaviour>().HasBrain = false;
  GameObject Limb4 = person.Limbs[3].gameObject;
  Limb4.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin4.png");
  Limb4.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh4.png").texture);
  Limb4.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone4.png").texture);
  Limb4.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage4.png").texture);
  Limb4.transform.localPosition = new Vector3(0.7035922f, -0.137238f, -0.1f);
  Limb4.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
  Limb4.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Legs;
  Limb4.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
  Limb4.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb4.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
  Limb4.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb4.GetComponent<LimbBehaviour>().InitialHealth = 350f;
  Limb4.GetComponent<LimbBehaviour>().Health = 350f;
  Limb4.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb4.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb4.GetComponent<LimbBehaviour>().Vitality = 2f;
  Limb4.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb4.GetComponent<CirculationBehaviour>().IsPump = false;
  Limb4.GetComponent<LimbBehaviour>().HasLungs = false;
  Limb4.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
  Limb4.GetComponent<LimbBehaviour>().HasBrain = false;
  GameObject Limb5 = person.Limbs[4].gameObject;
  Limb5.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin5.png");
  Limb5.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh5.png").texture);
  Limb5.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone5.png").texture);
  Limb5.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage5.png").texture);
  Limb5.transform.localPosition = new Vector3(0.6976948f, -0.1364275f, 0.1f);
  Limb5.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
  Limb5.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Legs;
  Limb5.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
  Limb5.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb5.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
  Limb5.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb5.GetComponent<LimbBehaviour>().InitialHealth = 350f;
  Limb5.GetComponent<LimbBehaviour>().Health = 350f;
  Limb5.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb5.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb5.GetComponent<LimbBehaviour>().Vitality = 2f;
  Limb5.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb5.GetComponent<CirculationBehaviour>().IsPump = false;
  Limb5.GetComponent<LimbBehaviour>().HasLungs = false;
  Limb5.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
  Limb5.GetComponent<LimbBehaviour>().HasBrain = false;
  GameObject Limb6 = person.Limbs[5].gameObject;
  Limb6.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin6.png");
  Limb6.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh6.png").texture);
  Limb6.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone6.png").texture);
  Limb6.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage6.png").texture);
  Limb6.transform.localPosition = new Vector3(-0.4295379f, -0.118129f, 0.1f);
  Limb6.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
  Limb6.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Legs;
  Limb6.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
  Limb6.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb6.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
  Limb6.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb6.GetComponent<LimbBehaviour>().InitialHealth = 350f;
  Limb6.GetComponent<LimbBehaviour>().Health = 350f;
  Limb6.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb6.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb6.GetComponent<LimbBehaviour>().Vitality = 2f;
  Limb6.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb6.GetComponent<CirculationBehaviour>().IsPump = false;
  Limb6.GetComponent<LimbBehaviour>().HasLungs = false;
  Limb6.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
  Limb6.GetComponent<LimbBehaviour>().HasBrain = false;
  GameObject Limb7 = person.Limbs[6].gameObject;
  Limb7.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin7.png");
  Limb7.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh7.png").texture);
  Limb7.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone7.png").texture);
  Limb7.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage7.png").texture);
  Limb7.transform.localPosition = new Vector3(-0.2468091f, 0.3253507f, 0.1f);
  Limb7.transform.eulerAngles = new Vector3(0f, 0f, 19.99685f) * Mathf.Sign(person.transform.localScale.x);
  Limb7.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Arms;
  Limb7.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
  Limb7.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb7.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
  Limb7.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb7.GetComponent<LimbBehaviour>().InitialHealth = 350f;
  Limb7.GetComponent<LimbBehaviour>().Health = 350f;
  Limb7.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb7.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb7.GetComponent<LimbBehaviour>().Vitality = 2f;
  Limb7.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb7.GetComponent<CirculationBehaviour>().IsPump = false;
  Limb7.GetComponent<LimbBehaviour>().HasLungs = false;
  Limb7.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
  Limb7.GetComponent<LimbBehaviour>().HasBrain = false;
  GameObject Limb8 = person.Limbs[7].gameObject;
  Limb8.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteSkin8.png");
  Limb8.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteFlesh8.png").texture);
  Limb8.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteBone8.png").texture);
  Limb8.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ChompsterCreatureSprites/LimbSpriteDamage8.png").texture);
  Limb8.transform.localPosition = new Vector3(0.3911526f, 0.4589034f, 0.1f);
  Limb8.transform.eulerAngles = new Vector3(0f, 0f, 1.001786f) * Mathf.Sign(person.transform.localScale.x);
  Limb8.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Arms;
  Limb8.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
  Limb8.GetComponent<SpriteRenderer>().sortingOrder = 0;
  Limb8.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
  Limb8.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
  Limb8.GetComponent<LimbBehaviour>().InitialHealth = 350f;
  Limb8.GetComponent<LimbBehaviour>().Health = 350f;
  Limb8.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
  Limb8.GetComponent<LimbBehaviour>().BreakingThreshold = 1000f;
  Limb8.GetComponent<LimbBehaviour>().Vitality = 2f;
  Limb8.GetComponent<LimbBehaviour>().VitalParts = null;
  Limb8.AddComponent<GripBehaviour>().GripPosition = new Vector3(0.3696038f, -0.003877312f, ModAPI.PixelSize * 6f);
  Limb8.GetComponent<CirculationBehaviour>().IsPump = false;
  Limb8.GetComponent<LimbBehaviour>().HasLungs = false;
  Limb8.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
  Limb8.GetComponent<LimbBehaviour>().HasBrain = false;
  int limbCount = 8;

  GameObject.Destroy(Limb1.GetComponent<LimbBehaviour>().Joint);
  Limb1.GetComponent<LimbBehaviour>().HasJoint = false;
  Limb1.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb1.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb2.GetComponent<CirculationBehaviour>(),
   };
  Limb1.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb2.GetComponent<LimbBehaviour>(),
   };
  Limb1.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb2.GetComponent<SkinMaterialHandler>(),
   };
  Limb2.GetComponent<GoreStringBehaviour>().Other = Limb1.GetComponent<Rigidbody2D>();
  var Limb2Joint = Limb2.GetComponent<LimbBehaviour>().Joint;
  Limb2Joint.anchor = new Vector2(-0.6362394f, 0.09502806f);
  Limb2Joint.autoConfigureConnectedAnchor = true;  Limb2Joint.connectedBody = Limb1.GetComponent<Rigidbody2D>();
  var lim2 = Limb2Joint.limits;
lim2.min = 0f;
lim2.max = 106.4535f;
Limb2Joint.limits = lim2;
  Limb2.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb1.GetComponent<ConnectedNodeBehaviour>(),
       Limb3.GetComponent<ConnectedNodeBehaviour>(),
       Limb4.GetComponent<ConnectedNodeBehaviour>(),
       Limb6.GetComponent<ConnectedNodeBehaviour>(),
       Limb5.GetComponent<ConnectedNodeBehaviour>(),
       Limb7.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb2.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb1.GetComponent<CirculationBehaviour>(),
       Limb3.GetComponent<CirculationBehaviour>(),
       Limb4.GetComponent<CirculationBehaviour>(),
       Limb6.GetComponent<CirculationBehaviour>(),
       Limb5.GetComponent<CirculationBehaviour>(),
       Limb7.GetComponent<CirculationBehaviour>(),
   };
  Limb2.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb1.GetComponent<LimbBehaviour>(),
       Limb3.GetComponent<LimbBehaviour>(),
       Limb4.GetComponent<LimbBehaviour>(),
       Limb6.GetComponent<LimbBehaviour>(),
       Limb5.GetComponent<LimbBehaviour>(),
       Limb7.GetComponent<LimbBehaviour>(),
   };
  Limb2.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb1.GetComponent<SkinMaterialHandler>(),
       Limb3.GetComponent<SkinMaterialHandler>(),
       Limb4.GetComponent<SkinMaterialHandler>(),
       Limb6.GetComponent<SkinMaterialHandler>(),
       Limb5.GetComponent<SkinMaterialHandler>(),
       Limb7.GetComponent<SkinMaterialHandler>(),
   };
  Limb2Joint.useLimits = false;
  Limb3.GetComponent<LimbBehaviour>().Joint = Limb3.AddComponent<HingeJoint2D>();
  Limb3.GetComponent<LimbBehaviour>().HasJoint = true;
  Limb3.AddComponent<GoreStringBehaviour>().Other = Limb2.GetComponent<Rigidbody2D>();
  var Limb3Joint = Limb3.GetComponent<LimbBehaviour>().Joint;
  Limb3Joint.anchor = new Vector2(-0.07761121f, 0.12237f);
  Limb3Joint.autoConfigureConnectedAnchor = true;  Limb3Joint.connectedBody = Limb2.GetComponent<Rigidbody2D>();
  var lim3 = Limb3Joint.limits;
lim3.min = 54.16994f;
lim3.max = -2.440009f;
Limb3Joint.limits = lim3;
  Limb3.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb3.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb2.GetComponent<CirculationBehaviour>(),
   };
  Limb3.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb2.GetComponent<LimbBehaviour>(),
   };
  Limb3.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb2.GetComponent<SkinMaterialHandler>(),
   };
  Limb3Joint.useLimits = false;
  Limb4.GetComponent<GoreStringBehaviour>().Other = Limb2.GetComponent<Rigidbody2D>();
  var Limb4Joint = Limb4.GetComponent<LimbBehaviour>().Joint;
  Limb4Joint.anchor = new Vector2(-0.08085948f, 0.1200978f);
  Limb4Joint.autoConfigureConnectedAnchor = true;  Limb4Joint.connectedBody = Limb2.GetComponent<Rigidbody2D>();
  var lim4 = Limb4Joint.limits;
lim4.min = 432.2628f;
lim4.max = -1.226376f;
Limb4Joint.limits = lim4;
  Limb4.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb4.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb2.GetComponent<CirculationBehaviour>(),
   };
  Limb4.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb2.GetComponent<LimbBehaviour>(),
   };
  Limb4.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb2.GetComponent<SkinMaterialHandler>(),
   };
  Limb4Joint.useLimits = false;
  Limb5.GetComponent<GoreStringBehaviour>().Other = Limb2.GetComponent<Rigidbody2D>();
  var Limb5Joint = Limb5.GetComponent<LimbBehaviour>().Joint;
  Limb5Joint.anchor = new Vector2(-0.08661139f, 0.1343027f);
  Limb5Joint.autoConfigureConnectedAnchor = true;  Limb5Joint.connectedBody = Limb2.GetComponent<Rigidbody2D>();
  var lim5 = Limb5Joint.limits;
lim5.min = 75.89128f;
lim5.max = -1.489634f;
Limb5Joint.limits = lim5;
  Limb5.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb5.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb2.GetComponent<CirculationBehaviour>(),
   };
  Limb5.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb2.GetComponent<LimbBehaviour>(),
   };
  Limb5.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb2.GetComponent<SkinMaterialHandler>(),
   };
  Limb5Joint.useLimits = false;
  Limb6.GetComponent<GoreStringBehaviour>().Other = Limb2.GetComponent<Rigidbody2D>();
  var Limb6Joint = Limb6.GetComponent<LimbBehaviour>().Joint;
  Limb6Joint.anchor = new Vector2(-0.1320293f, 0.1233841f);
  Limb6Joint.autoConfigureConnectedAnchor = true;  Limb6Joint.connectedBody = Limb2.GetComponent<Rigidbody2D>();
  var lim6 = Limb6Joint.limits;
lim6.min = 19.20363f;
lim6.max = -2.300337f;
Limb6Joint.limits = lim6;
  Limb6.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb6.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb2.GetComponent<CirculationBehaviour>(),
   };
  Limb6.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb2.GetComponent<LimbBehaviour>(),
   };
  Limb6.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb2.GetComponent<SkinMaterialHandler>(),
   };
  Limb6Joint.useLimits = false;
  Limb7.GetComponent<GoreStringBehaviour>().Other = Limb2.GetComponent<Rigidbody2D>();
  var Limb7Joint = Limb7.GetComponent<LimbBehaviour>().Joint;
  Limb7Joint.anchor = new Vector2(-0.251144f, 0.01998781f);
  Limb7Joint.autoConfigureConnectedAnchor = true;  Limb7Joint.connectedBody = Limb2.GetComponent<Rigidbody2D>();
  var lim7 = Limb7Joint.limits;
lim7.min = 1.752377E-05f;
lim7.max = 47.12111f;
Limb7Joint.limits = lim7;
  Limb7.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb8.GetComponent<ConnectedNodeBehaviour>(),
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb7.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb8.GetComponent<CirculationBehaviour>(),
       Limb2.GetComponent<CirculationBehaviour>(),
   };
  Limb7.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb8.GetComponent<LimbBehaviour>(),
       Limb2.GetComponent<LimbBehaviour>(),
   };
  Limb7.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb8.GetComponent<SkinMaterialHandler>(),
       Limb2.GetComponent<SkinMaterialHandler>(),
   };
  Limb7Joint.useLimits = false;
  Limb8.GetComponent<GoreStringBehaviour>().Other = Limb7.GetComponent<Rigidbody2D>();
  var Limb8Joint = Limb8.GetComponent<LimbBehaviour>().Joint;
  Limb8Joint.anchor = new Vector2(-0.2458537f, 0.006126915f);
  Limb8Joint.autoConfigureConnectedAnchor = true;  Limb8Joint.connectedBody = Limb7.GetComponent<Rigidbody2D>();
  var lim8 = Limb8Joint.limits;
lim8.min = 0f;
lim8.max = 90f;
Limb8Joint.limits = lim8;
  Limb8.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb7.GetComponent<ConnectedNodeBehaviour>(),
   };
  Limb8.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb7.GetComponent<CirculationBehaviour>(),
   };
  Limb8.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb7.GetComponent<LimbBehaviour>(),
   };
  Limb8.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb7.GetComponent<SkinMaterialHandler>(),
   };
  Limb8Joint.useLimits = false;


			for(int i = limbCount; i < person.Limbs.Length; i++)
            {
				person.Limbs[i].PhysicalBehaviour.Disintegrate();
			}

			foreach (var Limb in person.Limbs)
			{
				Limb.gameObject.FixColliders();
			}
			var nocol = Instance.AddComponent<NoCollide>();
			nocol.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
			nocol.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();

			person.LinkedPoses[PoseState.Rest].Angles = new List<RagdollPose.LimbPose>();
			foreach (var limb in person.Limbs)
			{
				if (limb != null && !limb.PhysicalBehaviour.isDisintegrated && limb.HasJoint)
                {
					person.LinkedPoses[PoseState.Rest].Angles.Add(new RagdollPose.LimbPose(limb, limb.Joint.jointAngle + (limb.transform.eulerAngles.z - limb.Joint.connectedBody.transform.eulerAngles.z) * Mathf.Sign(person.transform.localScale.x)));
				}
			}
			person.LinkedPoses[PoseState.Rest].ConstructDictionary();

			person.LinkedPoses[PoseState.Protective].Angles = new List<RagdollPose.LimbPose>();
			foreach (var limb in person.Limbs)
			{
				if (limb != null && !limb.PhysicalBehaviour.isDisintegrated && limb.HasJoint)
                {
					person.LinkedPoses[PoseState.Protective].Angles.Add(new RagdollPose.LimbPose(limb, limb.Joint.jointAngle + (limb.transform.eulerAngles.z - limb.Joint.connectedBody.transform.eulerAngles.z) * Mathf.Sign(person.transform.localScale.x)));
				}
			}
			person.LinkedPoses[PoseState.Protective].ConstructDictionary();

			foreach (var item in person.Limbs)
                        {
                            if(item.RoughClassification == LimbBehaviour.BodyPart.Head)
                            {
                                item.NodeBehaviour.IsRoot = true;
                                item.NodeBehaviour.Value = 1000000;
                            }
                            else
                            {
                                item.NodeBehaviour.IsRoot = false;
                                item.NodeBehaviour.Value = 100000;
                            }
                        }

                        foreach (var item in person.Limbs)
                        {
                            if (item.RoughClassification == LimbBehaviour.BodyPart.Head)
                            {
                                item.NodeBehaviour.RootPropagation();
                            }
                        }
		}
	}
);
        }
    }
}